/* -*- Mode: C; tab-width: 8; indent-tabs-mode: nil; c-basic-offset: 8 -*- */
/*
 * Chroma widget set
 * (C) 2005 M. Derezynski <internalerror@gmail.com> 
 *
 */

#ifndef CHROMA_BUTTON_H
#define CHROMA_BUTTON_H

#include <glib-object.h>
#include "bmp_ui.h"
#include "ui_util.h"

#define CHROMA_TYPE_BUTTON		  (chroma_button_get_type ())
#define CHROMA_BUTTON(obj)		  (G_TYPE_CHECK_INSTANCE_CAST ((obj), CHROMA_TYPE_BUTTON, ChromaButton))
#define CHROMA_BUTTON_CLASS(klass)	  (G_TYPE_CHECK_CLASS_CAST ((klass), CHROMA_TYPE_BUTTON, ChromaButtonClass))
#define CHROMA_IS_BUTTON(obj)	  (GTK_CHECK_TYPE ((obj), CHROMA_TYPE_BUTTON))
#define CHROMA_IS_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CHROMA_TYPE_BUTTON))
#define CHROMA_BUTTON_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), CHROMA_TYPE_BUTTON, ChromaButtonClass))

typedef struct _ChromaButton ChromaButton;
typedef struct _ChromaButtonClass ChromaButtonClass;
typedef struct _ChromaButtonPrivate ChromaButtonPrivate;

struct _ChromaButton {
	GObject parent;

        ChromaButtonPrivate *private;
};

struct _ChromaButtonClass {
	GObjectClass parent;

	void (*expose_request) (ChromaButton *scrollbar);
	void (*clicked)        (ChromaButton *scrollbar);
};

GType chroma_button_get_type (void);

GObject*
chroma_button_new (gint position_x, gint position_y, gint width, gint height); 

void
chroma_button_renew (ChromaButton *self, GtkWidget *widget, unsigned char data[]);

void
chroma_button_draw (ChromaButton *self, GtkWidget *widget);

gboolean
chroma_button_dispatch_button_press (ChromaButton *self, gint event_x, gint event_y, gboolean active, guint modifier_state);

gboolean
chroma_button_dispatch_button_release (ChromaButton *self, gint event_x, gint event_y);

gboolean
chroma_button_dispatch_motion (ChromaButton *self, gint event_x, gint event_y);

#endif /* CHROMA_BUTTON_H */



