#ifndef UI_EQUALIZER_H
#define UI_EQUALIZER_H

#include "bmp_window.h"
#include <glib-object.h>

#define BMP_TYPE_WINDOW_EQUALIZER		  (bmp_window_equalizer_get_type ())
#define BMP_WINDOW_EQUALIZER(obj)		  (G_TYPE_CHECK_INSTANCE_CAST ((obj), BMP_TYPE_WINDOW_EQUALIZER, BmpWindowEqualizer))
#define BMP_WINDOW_EQUALIZER_CLASS(klass)	  (G_TYPE_CHECK_CLASS_CAST ((klass), BMP_TYPE_WINDOW_EQUALIZER, BmpWindowEqualizerClass))
#define BMP_IS_WINDOW_EQUALIZER(obj)	  (GTK_CHECK_TYPE ((obj), BMP_TYPE_WINDOW_EQUALIZER))
#define BMP_IS_WINDOW_EQUALIZER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BMP_TYPE_WINDOW_EQUALIZER))
#define BMP_WINDOW_EQUALIZER_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), BMP_TYPE_WINDOW_EQUALIZER, BmpWindowEqualizerClass))

typedef struct _BmpWindowEqualizer BmpWindowEqualizer;
typedef struct _BmpWindowEqualizerClass BmpWindowEqualizerClass;
typedef struct _BmpWindowEqualizerPrivate BmpWindowEqualizerPrivate;

struct _BmpWindowEqualizer {
	GObject parent;

        BmpWindowEqualizerPrivate *private;

	GtkWidget *window;
};

struct _BmpWindowEqualizerClass {
	GObjectClass parent;
};

#define BMP_UI_EQUALIZER_N_SLIDERS 10

GType
bmp_window_equalizer_get_type (void);

BmpWindowEqualizer*
bmp_window_equalizer_new (void);
 
void 
bmp_window_equalizer_configure(BmpWindowEqualizer *window_equalizer);

void
bmp_window_equalizer_iconify (BmpWindowEqualizer *self);

#endif /* UI_EQUALIZER_H */
